using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;


namespace NestedTableHide
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl WidgetGroupingGrid;
        private NestedTableHide.WidgetDataSet WidgetData;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
            GridEngineFactory.Factory = new CustomGroupingEngineFactory();

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor gridColumnDescriptor1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor();
			Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor gridColumnDescriptor2 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor();
			this.WidgetData = new NestedTableHide.WidgetDataSet();
			this.WidgetGroupingGrid = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.WidgetData)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.WidgetGroupingGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// WidgetData
			// 
			this.WidgetData.DataSetName = "WidgetDataSet";
			this.WidgetData.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// WidgetGroupingGrid
			// 
			this.WidgetGroupingGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.WidgetGroupingGrid.BackColor = System.Drawing.SystemColors.Window;
			this.WidgetGroupingGrid.DataMember = "Widget";
			this.WidgetGroupingGrid.DataSource = this.WidgetData;
			this.WidgetGroupingGrid.Location = new System.Drawing.Point(8, 8);
			this.WidgetGroupingGrid.Name = "WidgetGroupingGrid";
			this.WidgetGroupingGrid.Size = new System.Drawing.Size(520, 344);
			this.WidgetGroupingGrid.TabIndex = 0;
			gridColumnDescriptor1.MappingName = "Name";
			gridColumnDescriptor1.Width = 150;
			gridColumnDescriptor2.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
			gridColumnDescriptor2.Appearance.AnyRecordFieldCell.DataSource = this.WidgetData.WidgetType;
			gridColumnDescriptor2.Appearance.AnyRecordFieldCell.DisplayMember = "Name";
			gridColumnDescriptor2.Appearance.AnyRecordFieldCell.ValueMember = "WidgetTypeID";
			gridColumnDescriptor2.HeaderText = "Widget Type";
			gridColumnDescriptor2.MappingName = "WidgetTypeID";
			gridColumnDescriptor2.Width = 150;
			this.WidgetGroupingGrid.TableDescriptor.Columns.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
																																		   gridColumnDescriptor1,
																																		   gridColumnDescriptor2});
			this.WidgetGroupingGrid.Text = "gridGroupingControl1";
			this.WidgetGroupingGrid.VersionInfo = "4.101.0.63";
			this.WidgetGroupingGrid.RecordExpanding += new Syncfusion.Grouping.RecordEventHandler(this.WidgetGroupingGrid_RecordExpanding);
			this.WidgetGroupingGrid.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.WidgetGroupingGrid_TableControlCurrentCellCloseDropDown);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 389);
			this.Controls.Add(this.WidgetGroupingGrid);
			this.Name = "MainForm";
			this.Text = "Widget Grouping Example";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.WidgetData)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.WidgetGroupingGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}


        private void LoadData() 
        {
            // We only want to show the WidgetMaintenanceLog child table for "Industrial Widgets"
            WidgetDataSet.WidgetTypeRow industrialWidgetTypeRow = this.WidgetData.WidgetType.NewWidgetTypeRow();
            industrialWidgetTypeRow.WidgetTypeID = 1;
            industrialWidgetTypeRow.Name = "Industrial Widget";
            this.WidgetData.WidgetType.AddWidgetTypeRow(industrialWidgetTypeRow);

            // We DO NOT want to show the WidgetMaintenanceLog for "Toy Widgets"
            WidgetDataSet.WidgetTypeRow toyWidgetTypeRow = this.WidgetData.WidgetType.NewWidgetTypeRow();
            toyWidgetTypeRow.WidgetTypeID = 2;
            toyWidgetTypeRow.Name = "Toy Widget";
            this.WidgetData.WidgetType.AddWidgetTypeRow(toyWidgetTypeRow);

            // The user should be able to add maintenance log entries for this Bulldozer
            WidgetDataSet.WidgetRow widgetRow = this.WidgetData.Widget.NewWidgetRow();
            widgetRow.Name = "Bulldozer";
            widgetRow.WidgetTypeRow = industrialWidgetTypeRow;
            this.WidgetData.Widget.AddWidgetRow(widgetRow);

            // Add some parts for the "Bulldozer" widget object
            WidgetDataSet.WidgetPartsListRow partsRow = this.WidgetData.WidgetPartsList.NewWidgetPartsListRow();
            partsRow.WidgetRow = widgetRow;
            partsRow.Name = "Bulldozer blade";
            this.WidgetData.WidgetPartsList.AddWidgetPartsListRow(partsRow);

            partsRow = this.WidgetData.WidgetPartsList.NewWidgetPartsListRow();
            partsRow.WidgetRow = widgetRow;
            partsRow.Name = "Diesel Engine";
            this.WidgetData.WidgetPartsList.AddWidgetPartsListRow(partsRow);


            // The user should NOT be able to add maintenance log entries for this Tonka Truck
            // Futher, we do not even want to show the WidgetMaintenanceLog child table for this item 
            // because its WidgetTypeID is set to 2.
            // However, we do want to show the parts list for the Tonka Truck
            widgetRow = this.WidgetData.Widget.NewWidgetRow();
            widgetRow.Name = "Tonka Truck";
            widgetRow.WidgetTypeRow = toyWidgetTypeRow;
            this.WidgetData.Widget.AddWidgetRow(widgetRow);

            // Add some parts for the Tonka Truck
            partsRow = this.WidgetData.WidgetPartsList.NewWidgetPartsListRow();
            partsRow.WidgetRow = widgetRow;
            partsRow.Name = "Plastic Wheels";
            this.WidgetData.WidgetPartsList.AddWidgetPartsListRow(partsRow);

            partsRow = this.WidgetData.WidgetPartsList.NewWidgetPartsListRow();
            partsRow.WidgetRow = widgetRow;
            partsRow.Name = "Yellow Paint";
            this.WidgetData.WidgetPartsList.AddWidgetPartsListRow(partsRow);
        }


        private void MainForm_Load(object sender, System.EventArgs e)
        {
            this.LoadData();
        }

		private void WidgetGroupingGrid_RecordExpanding(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
//			if( e.Record != null )
//			{
//				object obj = e.Record.GetValue("WidgetTypeID");
//				if( obj != null && obj.ToString() == "2")  
//					e.Cancel = true;
//			}
		}

		private void WidgetGroupingGrid_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
//			if(e.Inner.PopupCloseType == Syncfusion.Windows.Forms.PopupCloseType.Done )
//			{
//				GridTableCellStyleInfo tableCellStyle = e.TableControl.CurrentCell.Renderer.CurrentStyle as GridTableCellStyleInfo ;
//				if( tableCellStyle.TableCellIdentity.Column != null &&  tableCellStyle.TableCellIdentity.Column.Name == "WidgetTypeID"  && tableCellStyle.TableCellIdentity.DisplayElement.Kind != DisplayElementKind.AddNewRecord  ) 
//				{
//					e.TableControl.Table.CurrentRecord.EndEdit();
//					if( e.TableControl.CurrentCell.Renderer.ControlValue.Equals(2 ) )
//						e.TableControl.Table.CurrentRecord.IsExpanded = false;
//				}
//			}

		}
	}
}
